package gckovats;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

// Class created by Simon Dellicour (April 2011 & November 2012).

public class InputFileReader 
{	
	public ArrayList<String> lines1;
	public ArrayList<String> lines2;
	public String inputName;
	public double maximumNumberOfDataRows;
	public double numberOfDataColumns;
	public double numberOfColumnsPerInjection;
	public double numberOfIndividuals;
	public ArrayList<Individual> individuals;
	public String individualsList;
	public String origins;
	public ArrayList<String> calibrationRetentionTimes;
	public ArrayList<String> numberOfCarbons;

	// IMPORTANT NOTE : to easily understand these distinctions, it is quite better to look at the input file structure...

	public void readInput(String inputName) throws IOException 
		{
			BufferedReader in = new BufferedReader(new FileReader(inputName));
			String s1;
			ArrayList<String> lines0 = new ArrayList<String>();
			while ((s1 = in.readLine()) != null)
				lines0.add(s1);
			lines1 = lines0;
			maximumNumberOfDataRows = lines1.size() - 2;
			in.close();
			
			individualsList = lines1.get(0);
			origins = lines1.get(1);
			String[] line2 = lines1.get(2).split("	");
			numberOfDataColumns = line2.length;
			numberOfColumnsPerInjection = MainClass.numberOfColumnsPerInjection;
			numberOfIndividuals = numberOfDataColumns/numberOfColumnsPerInjection;
			
			individuals = new ArrayList<Individual>();
			for (int i = 0; i < (int) numberOfIndividuals; i++)
				{
					Individual individual = new Individual(i + 1);
					individuals.add(individual);
				}
	
			for (int i = 2; i < maximumNumberOfDataRows + 2; i++)
				{
					String s2 = new String();
					s2 = lines1.get(i);
					String[] line = s2.split("	");
					for (int j = 0; j < numberOfIndividuals; j++)
						{
							if (j < (line.length/numberOfColumnsPerInjection))
								{
									int k = (int) (((j+1)*numberOfColumnsPerInjection) - numberOfColumnsPerInjection);
									String string1 = new String();
									String string2 = new String();
									for (int l = 0; l < (int) numberOfColumnsPerInjection; l++)
										{
											string1 = string1 + line[k+l];
											if (l < ((int) numberOfColumnsPerInjection - 1))
													{
														string1 = string1 + "	";
													}
										}
									for (int l = 1; l < (int) numberOfColumnsPerInjection; l++)
										{
											string2 = string2 + line[k+l];
											if (l < ((int) numberOfColumnsPerInjection - 1))
													{
														string2 = string2 + "	";
													}
										}	
									individuals.get(j).columns.add(string1);
									individuals.get(j).retensionTimesString.add(line[k+0]);
									individuals.get(j).columnsWithoutRetentionTimes.add(string2);
								}
							else
								{
									String string = new String(); // "	" + "	" + "	";
									
									for (int l = 0; l < (int) numberOfColumnsPerInjection; l++)
										{
											string = string + "	"; // System.out.println(l+1);
										}
									
									individuals.get(j).columns.add(string);
									individuals.get(j).retensionTimesString.add("");
								}
						}
				}
		}
	
	public void readCalibration(String calibrationName) throws IOException 
		{
			BufferedReader in = new BufferedReader(new FileReader(calibrationName));
			String s1;
			ArrayList<String> lines0 = new ArrayList<String>();
			while ((s1 = in.readLine()) != null)
				lines0.add(s1);
			lines2 = lines0;
			double maximumNumberOfCalibrationRows = lines2.size() - 2;
			in.close();
			
			calibrationRetentionTimes = new ArrayList<String>();
			numberOfCarbons = new ArrayList<String>();
	
			for (int i = 2; i < maximumNumberOfCalibrationRows + 2; i++)
				{
					String s2 = new String();
					s2 = lines2.get(i);
					String[] line = s2.split("	");
					calibrationRetentionTimes.add(line[0]);
					numberOfCarbons.add(line[1]);
				}
		}
}
