package gckovats;

import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextField;
import java.awt.Color;
import javax.swing.border.LineBorder;
import javax.swing.SwingConstants;
import java.awt.Font;
import javax.swing.JPopupMenu;
import java.awt.Component;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Dimension;
import javax.swing.JTextPane;
import java.io.File;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class Interface extends JFrame 
{
	private static final long serialVersionUID = 1L;
	private JTextField inputFileName;
	private JTextField numberOfColumns;
	private JButton run = null;
	private JTextField calibrationFileName;
	public Interface() 
		{
			setResizable(false);
			// setIconImage(Toolkit.getDefaultToolkit().getImage(Interface.class.getResource("/images/test.jpg")));
			getContentPane().setBackground(Color.WHITE);
			setTitle("GCKovats 1.0");
			setSize(283, 263);
			getContentPane().setLayout(null);
			
			JPanel panel1 = new JPanel();
			panel1.setBorder(new LineBorder(new Color(192, 192, 192), 3));
			panel1.setBackground(Color.WHITE);
			panel1.setBounds(-11, -20, 304, 79);
			getContentPane().add(panel1);
			panel1.setLayout(null);
			
			JLabel lblDellicourSLecocq = new JLabel("ebe.ulb.ac.be/ebe/Software.html");
			lblDellicourSLecocq.setBounds(25, 48, 167, 16);
			panel1.add(lblDellicourSLecocq);
			lblDellicourSLecocq.setFont(new Font("Arial", Font.PLAIN, 11));
			
			JLabel lblDellicourSLecocq_1 = new JLabel("Dellicour S, Lecocq T (2013)");
			lblDellicourSLecocq_1.setBounds(25, 31, 167, 16);
			panel1.add(lblDellicourSLecocq_1);
			lblDellicourSLecocq_1.setFont(new Font("Arial", Font.PLAIN, 12));
			
			JPanel panel2 = new JPanel();
			panel2.setBorder(new LineBorder(Color.LIGHT_GRAY, 3));
			panel2.setBackground(Color.WHITE);
			panel2.setBounds(-11, 51, 304, 201);
			getContentPane().add(panel2);
			panel2.setLayout(null);
			
			JLabel label1 = new JLabel("Inputfile (tab delimited): ");
			label1.setFont(new Font("Arial", Font.PLAIN, 12));
			label1.setBounds(26, 87, 177, 16);
			panel2.add(label1);
			
			inputFileName = new JTextField();
			inputFileName.setFont(new Font("Arial", Font.PLAIN, 10));
			// inputFileName.setText("(without a \".txt\" extension)");
			inputFileName.setBounds(26, 145, 177, 22);
			panel2.add(inputFileName);
			inputFileName.setColumns(10);
			
			run = new JButton("RUN");
			run.setFont(new Font("Arial", Font.BOLD, 10));
			run.setBounds(210, 115, 61, 52);
			panel2.add(run);
			
			JButton open1 = new JButton("OPEN");
			open1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
				}
			});
			open1.setFont(new Font("Arial", Font.BOLD, 10));
			open1.setBounds(207, 84, 64, 22);
			panel2.add(open1);
			
			JLabel lblNberOfColumnsinjection = new JLabel("Nber of columns/sample:");
			lblNberOfColumnsinjection.setBounds(26, 25, 193, 16);
			panel2.add(lblNberOfColumnsinjection);
			lblNberOfColumnsinjection.setFont(new Font("Arial", Font.PLAIN, 12));
			
			numberOfColumns = new JTextField();
			numberOfColumns.setFont(new Font("Arial", Font.PLAIN, 12));
			numberOfColumns.setBounds(171, 21, 48, 24);
			panel2.add(numberOfColumns);
			numberOfColumns.setHorizontalAlignment(SwingConstants.CENTER);
			numberOfColumns.setText("3");
			numberOfColumns.setColumns(10);
			
			JButton interrogationNberOfColumns = new JButton("?");
			interrogationNberOfColumns.setBounds(227, 22, 44, 22);
			panel2.add(interrogationNberOfColumns);
			interrogationNberOfColumns.setFont(new Font("Arial", Font.PLAIN, 11));
			
			final JPopupMenu popupMenu1 = new JPopupMenu();
			popupMenu1.setBorderPainted(false);
			popupMenu1.setFont(new Font("Arial", Font.PLAIN, 11));
			popupMenu1.setPopupSize(new Dimension(400, 35));
			addPopup(interrogationNberOfColumns, popupMenu1);
			
			JTextPane text2 = new JTextPane();
			text2.setFont(new Font("Arial", Font.PLAIN, 11));
			text2.setEditable(false);
			text2.setText("This the number of columns per injection/sample in the input file (including the compulsory first columns with the retention times).");
			popupMenu1.add(text2);
			
			JButton interrogationInputFile = new JButton("?");
			interrogationInputFile.setFont(new Font("Arial", Font.PLAIN, 11));
			interrogationInputFile.setBounds(162, 84, 44, 22);
			panel2.add(interrogationInputFile);
			
			final JPopupMenu popupMenu3 = new JPopupMenu();
			popupMenu3.setBorderPainted(false);
			popupMenu3.setFont(new Font("Arial", Font.PLAIN, 11));
			popupMenu3.setPopupSize(new Dimension(400, 110));
			addPopup(interrogationInputFile, popupMenu3);
			
			JTextPane text3 = new JTextPane();
			text3.setFont(new Font("Arial", Font.PLAIN, 11));
			text3.setText("The second input file GCKovats needs is the same as for GCAligner. In this tab delimited file, the first column of each sample/injection must always be the RT column. The program does not read the other columns, which will only be copied in the output file. The number of additional columns to the RT column is not limited but has to be specified before running the program (cfr. software manual). Empty data are not allowed. The two first lines are not read. They can contain any useful information for users but input files need to present two lines before the different columns per sample.\r");
			text3.setEditable(false);
			popupMenu3.add(text3);
			
			JLabel label2 = new JLabel("Calibration (alkanes):");
			label2.setFont(new Font("Arial", Font.PLAIN, 12));
			label2.setBounds(26, 56, 177, 16);
			panel2.add(label2);
			
			JButton interrogationCalibrationFile = new JButton("?");
			interrogationCalibrationFile.setFont(new Font("Arial", Font.PLAIN, 11));
			interrogationCalibrationFile.setBounds(162, 53, 44, 22);
			panel2.add(interrogationCalibrationFile);
			
			final JPopupMenu popupMenu2 = new JPopupMenu();
			popupMenu2.setPopupSize(new Dimension(400, 110));
			popupMenu2.setFont(new Font("Arial", Font.PLAIN, 11));
			popupMenu2.setBorderPainted(false);
			addPopup(interrogationCalibrationFile, popupMenu2);
			
			JTextPane txtpnGckovatsFirstlyNeeds = new JTextPane();
			txtpnGckovatsFirstlyNeeds.setText("GCKovats firstly needs a \"calibration file\": a \u00AB.txt\u00BB tab delimited file displaying the RT of several or all the n-alkanes from the calibration solution (first column) and the number of carbon atoms of each alkane (second column). Please note that the two first lines are not read. They can contain any useful information for users but, as for GCAligner, this input file needs to present two lines before the n-alkanes RT and number of carbon atoms. It is also important to underline that the range of samples RT have to be included into the range of n-alkanes RT. See the software manual for further details.\r");
			txtpnGckovatsFirstlyNeeds.setFont(new Font("Arial", Font.PLAIN, 11));
			txtpnGckovatsFirstlyNeeds.setEditable(false);
			popupMenu2.add(txtpnGckovatsFirstlyNeeds);
			
			JButton open2 = new JButton("OPEN");
			open2.setFont(new Font("Arial", Font.BOLD, 10));
			open2.setBounds(207, 53, 64, 22);
			panel2.add(open2);
			
			calibrationFileName = new JTextField();
			calibrationFileName.setFont(new Font("Arial", Font.PLAIN, 10));
			calibrationFileName.setColumns(10);
			calibrationFileName.setBounds(26, 115, 177, 22);
			panel2.add(calibrationFileName);
			
			interrogationNberOfColumns.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent arg0) {
					popupMenu1.show(arg0.getComponent(),
							arg0.getX(), arg0.getY());
				}
			});
			
			interrogationCalibrationFile.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent arg0) {
					popupMenu2.show(arg0.getComponent(),
							arg0.getX(), arg0.getY());
				}
			});
			
			interrogationInputFile.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent arg0) {
					popupMenu3.show(arg0.getComponent(),
							arg0.getX(), arg0.getY());
				}
			});
		
			final JFileChooser fileChooser1 = new JFileChooser();
			open1.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent arg0) {
				int returnVal = fileChooser1.showOpenDialog(null);
				if (returnVal == JFileChooser.APPROVE_OPTION) 
					{
						File selection = fileChooser1.getSelectedFile();
						inputFileName.setText(selection.getAbsolutePath());
					}
				}
			});
			
			final JFileChooser fileChooser2 = new JFileChooser();
			open2.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent arg0) {
				int returnVal = fileChooser2.showOpenDialog(null);
				if (returnVal == JFileChooser.APPROVE_OPTION) 
					{
						File selection = fileChooser2.getSelectedFile();
						calibrationFileName.setText(selection.getAbsolutePath());
					}
				}
			});
		}
	
	JButton getJButton() 
		{
			return run;
		}
	
	public String getInputNameText() 
		{
			String inputNameText = inputFileName.getText();
			return inputNameText;
		}
	
	public String getCalibrationNameText() 
		{
			String inputNameText = calibrationFileName.getText();
			return inputNameText;
		}
	
	public String getNumberOfColumnsPerInjectionText() 
		{
			String getNumberOfColumnsPerInjectionText = numberOfColumns.getText();
			return getNumberOfColumnsPerInjectionText;
		}
	
	private static void addPopup(Component component, final JPopupMenu popup) 
		{
		
		}
}

