package gckovats;

// Class created by Simon Dellicour (November 2012).

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;

public class MainClass 
{
	public static ArrayList<String> finalArray;
	// data coming from the interface :
	public static Interface window;
	public static JButton start;
	public static String inputName;
	public static String calibrationName;
	public static String numberOfColumnsPerInjectionText;
	public static double numberOfColumnsPerInjection;
	
	// data coming from the inputFileReader :
	public static ArrayList<ArrayList <Double>> originalArray;

	public static void main(String[] args) 
		{
			window = new Interface(); // creation of the interface.
			window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			window.setVisible(true); // necessary line to add to have a nice window.
			// window.setIconImage(new ImageIcon("Icon.PNG").getImage());
			start = window.getJButton();
	
			start.addActionListener(new ActionListener() 
				{
					public void actionPerformed(ActionEvent e) 
						{
							// inputName = (window.getInputNameText() + ".txt");
							// calibrationName = (window.getCalibrationNameText() + ".txt");
							inputName = window.getInputNameText();
							calibrationName = window.getCalibrationNameText();
							numberOfColumnsPerInjectionText = window.getNumberOfColumnsPerInjectionText();
							numberOfColumnsPerInjection = Double.valueOf(numberOfColumnsPerInjectionText);
							
							InputFileReader input = new InputFileReader(); 
								try {
									input.readInput(inputName);
								} catch (IOException e3) {
									// TODO Auto-generated catch block
									e3.printStackTrace();
								}						
							finalArray = new ArrayList<String>();
							finalArray.add(input.individualsList);
							finalArray.add(input.origins);
								try {
									input.readCalibration(calibrationName);
								} catch (IOException e3) {
									// TODO Auto-generated catch block
									e3.printStackTrace();
								}	
							
							ArrayList<Double> calibrationRetentionTimes = new ArrayList<Double>();
							for (int i = 0; i < input.calibrationRetentionTimes.size(); i++)
								{	
									calibrationRetentionTimes.add(Double.valueOf(input.calibrationRetentionTimes.get(i)));
								} 
							ArrayList<Double> numberOfCarbons = new ArrayList<Double>();
							for (int i = 0; i < input.calibrationRetentionTimes.size(); i++)
								{	
									numberOfCarbons.add(Double.valueOf(input.numberOfCarbons.get(i)));
								}
							
							// identify the highest and smallest retention time :
							double maxValue0 = 0; int b0 = -1;
							for (int i = 0; i < input.calibrationRetentionTimes.size(); i++)
								{
									if (calibrationRetentionTimes.get(i).doubleValue() > maxValue0)
										{
											maxValue0 = calibrationRetentionTimes.get(i).doubleValue();
											b0 = i;
										}
								}	
							double minValue0 = maxValue0; int a0 = -1;
							for (int i = 0; i < input.calibrationRetentionTimes.size(); i++)
								{
									if (calibrationRetentionTimes.get(i).doubleValue() < minValue0)
										{
											minValue0 = calibrationRetentionTimes.get(i).doubleValue();
											a0 = i;
										}
								}
							
							for (int i = 0; i < input.individuals.size(); i++)
								{
									ArrayList<Double> sampleRetentionTimes = new ArrayList<Double>();
									for (int j = 0; j < input.individuals.get(i).retensionTimesString.size(); j++)
										{
											if (input.individuals.get(i).retensionTimesString.get(j).isEmpty())
												{	}
											else
												{
													sampleRetentionTimes.add(Double.valueOf(input.individuals.get(i).retensionTimesString.get(j)));
												}
										}
									for (int j = 0; j < sampleRetentionTimes.size(); j++)
										{
											double minValue = minValue0;
											double maxValue = maxValue0;
											int a = a0; // indice of alkane n.
											int b = b0; // indice of alkane n.		
											for (int k = 0; k < calibrationRetentionTimes.size(); k++)
												{
													if ((sampleRetentionTimes.get(j) > calibrationRetentionTimes.get(k)) && (sampleRetentionTimes.get(j)-calibrationRetentionTimes.get(k)) < (sampleRetentionTimes.get(j)-minValue))
														{
															minValue = calibrationRetentionTimes.get(k);
															a = k;
														}
													if ((calibrationRetentionTimes.get(k) > sampleRetentionTimes.get(j)) && (calibrationRetentionTimes.get(k)-sampleRetentionTimes.get(j)) < (maxValue-sampleRetentionTimes.get(j)))
														{
															maxValue = calibrationRetentionTimes.get(k);
															b = k;
														}
												}
											double I = -1;
											
											// System.out.println();
											// System.out.println("numberOfCarbons.get(a) = " + numberOfCarbons.get(a));
											// System.out.println("numberOfCarbons.get(b) = " + numberOfCarbons.get(b));
											// System.out.println("sampleRetentionTimes.get(j) = " + sampleRetentionTimes.get(j));
											// System.out.println(minValue + " - " + maxValue);
											I = 100*(numberOfCarbons.get(a)+((numberOfCarbons.get(b)-numberOfCarbons.get(a))*((sampleRetentionTimes.get(j)-minValue)/(maxValue-minValue))));
											// System.out.println("I = " + I);
											// String IString = new String(); Double IDouble = new Double(I); IString = IDouble.toString();
											float Ifloat = (float) I; String IString = new String(); Float IFloat = new Float(Ifloat); IString = IFloat.toString();
											input.individuals.get(i).kovatsI.add(IString);
										}
								}
							
							String row = new String();
							for (int i = 0; i < input.maximumNumberOfDataRows; i++)
								{
									row = new String();
									for (int j = 0; j < input.numberOfIndividuals; j++)
										{
											if (i < input.individuals.get(j).kovatsI.size())
												{
													row = row + input.individuals.get(j).kovatsI.get(i) + "	" + input.individuals.get(j).columnsWithoutRetentionTimes.get(i) + "	";
												}
											else
												{
													for (int l = 0; l < (int) numberOfColumnsPerInjection; l++)
														{
															row = row + "	";
														}
												}
										}
									finalArray.add(row);
								}
							
							// construction of the .txt or .xls output file :
							OutputFileWriter output1 = new OutputFileWriter();
							try {
									output1.writeOutput1(finalArray, "GCKovats_output_file.txt");
								} catch (IOException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
						} // end of "addActionListener".
				});
	} // end of "main".
}
